// @flow

// FIXME: move into separate package

declare interface Oniguruma$ScannerCaptureIndicesEntry {
  end: number;
  index: number;
  length: number;
  start: number;
}

declare interface Oniguruma$ScannerMatch {
  index: number;
  captureIndices: Oniguruma$ScannerCaptureIndicesEntry[];
}

declare class Oniguruma$Scanner {
  constructor(patterns: string[]): this;
  findNextMatch(
    string: string,
    startPosition?: number,
    callback: (error: Error, match: ?Oniguruma$ScannerMatch) => mixed,
  ): void;
  findNextMatchSync(
    string: string,
    startPosition?: number,
  ): ?Oniguruma$ScannerMatch;
}
